iscsi-root install will only use net0 for iscsi-target connectivity

Bug #473036 reported by ianand0204 on 2009-11-03
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
initramfs-tools (Ubuntu)
High
Colin Watson
open-iscsi (Ubuntu)
High
Colin Watson
partman-iscsi (Ubuntu)
High
Colin Watson

Bug Description

Binary package hint: partman-iscsi

Description: Ubuntu 9.10
Release: 9.10

Expected to happen:
Install ubuntu to iscsi target using NET1 for connectivity to target
Reboot system and use NET1 to connect to iscsi target

What happened instead:
Installed ubuntu to iscsi target using NET1 for connectivity to target
Reboot and initrd requires NET0 connectivity in order to connect to iscsi target
NET1 is never used, even though it was specified during install.

Replication Steps
PXE Server
A machine with more than one NIC,
An iscsi target to install to

Launch Ubuntu 9.10 Server installer (x86 or x64)
When you get to the menu that prompts for which interface you want to use for network connectivity select (NET1)
Use DHCP or Statically configure the NET1 interface.
When you get to partition editor, select the "Login to iscsi targets".
Configure the target, and complete the install.
When prompted to reboot, do so.

After the pxe process is complete, you'll notice that NET0 is being used to boot from iscsi, not NET1 as originally instructed within the installer.

Colin Watson (cjwatson) wrote :

Could you attach /etc/iscsi/iscsi.initramfs (if it exists), /var/log/installer/syslog, and /etc/network/interfaces, please?

Changed in partman-iscsi (Ubuntu):
status: New → Incomplete
Colin Watson (cjwatson) wrote :

ianand0204: Any progress on getting me these files with more information? I'd like to get this cleaned up for Lucid, but I will need those files in order to do so. Thanks in advance.

Unfortunately the machine I was using for this test has been rebuilt for
another group, so I lost all the config files.

On Wed, Jan 6, 2010 at 6:19 AM, Colin Watson <email address hidden> wrote:

> ianand0204: Any progress on getting me these files with more
> information? I'd like to get this cleaned up for Lucid, but I will need
> those files in order to do so. Thanks in advance.
>
> --
> iscsi-root install will only use net0 for iscsi-target connectivity
> https://bugs.launchpad.net/bugs/473036
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in “partman-iscsi” package in Ubuntu: Incomplete
>
> Bug description:
> Binary package hint: partman-iscsi
>
> Description: Ubuntu 9.10
> Release: 9.10
>
> Expected to happen:
> Install ubuntu to iscsi target using NET1 for connectivity to target
> Reboot system and use NET1 to connect to iscsi target
>
> What happened instead:
> Installed ubuntu to iscsi target using NET1 for connectivity to target
> Reboot and initrd requires NET0 connectivity in order to connect to iscsi
> target
> NET1 is never used, even though it was specified during install.
>
>
> Replication Steps
> PXE Server
> A machine with more than one NIC,
> An iscsi target to install to
>
> Launch Ubuntu 9.10 Server installer (x86 or x64)
> When you get to the menu that prompts for which interface you want to use
> for network connectivity select (NET1)
> Use DHCP or Statically configure the NET1 interface.
> When you get to partition editor, select the "Login to iscsi targets".
> Configure the target, and complete the install.
> When prompted to reboot, do so.
>
> After the pxe process is complete, you'll notice that NET0 is being used to
> boot from iscsi, not NET1 as originally instructed within the installer.
>
> To unsubscribe from this bug, go to:
>
> https://bugs.launchpad.net/ubuntu/+source/partman-iscsi/+bug/473036/+subscribe
>

Colin Watson (cjwatson) wrote :

Somebody else showed up on IRC with similar symptoms, so I've been making progress on this. So far, I've found three underlying problems:

 * initramfs-tools' configure_networking function is hardcoded (by means of /etc/initramfs-tools/initramfs.conf) to default to bringing up eth0. partman-iscsi needs to remember which device was configured in netcfg, and open-iscsi needs to make use of that in its initramfs script.
 * /etc/udev/rules.d/70-persistent-net.rules is not copied into the initramfs, so network device order in the initramfs is not deterministic. I'm not sure right now whether to do that in open-iscsi or centrally in udev, given that a similar problem is likely to afflict NFS-root and NBD-root cases.

Changed in partman-iscsi (Ubuntu):
assignee: nobody → Colin Watson (cjwatson)
importance: Undecided → High
status: Incomplete → In Progress
Colin Watson (cjwatson) wrote :

Of course I meant TWO underlying problems. (Among our problems ...)

Changed in open-iscsi (Ubuntu):
assignee: nobody → Colin Watson (cjwatson)
importance: Undecided → High
status: New → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package partman-iscsi - 12

---------------
partman-iscsi (12) lucid; urgency=low

  * Remember the default network interface and record it in ISCSI_NETDEVICE
    in iscsi.initramfs (LP: #473036).
 -- Colin Watson <email address hidden> Fri, 22 Jan 2010 17:00:15 +0000

Changed in partman-iscsi (Ubuntu):
status: In Progress → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package open-iscsi - 2.0.871-0ubuntu3

---------------
open-iscsi (2.0.871-0ubuntu3) lucid; urgency=low

  * If ISCSI_NETDEVICE is set, configure that interface in the initramfs
    (LP: #473036).
 -- Colin Watson <email address hidden> Fri, 22 Jan 2010 17:01:17 +0000

Changed in open-iscsi (Ubuntu):
status: In Progress → Fix Released
Colin Watson (cjwatson) wrote :

OK, new plan after talking to Scott. Hardwiring device names into the initramfs means that if you ever swap network cards and forget to regenerate the initramfs then everything goes wrong. Instead, we'll add a facility to select network devices during initramfs network configuration by MAC address (and fall back to the previous behaviour if the MAC address selected that way doesn't exist). The network device might get renamed on entering the real system, but that's OK.

Changed in open-iscsi (Ubuntu):
status: Fix Released → Triaged
Changed in initramfs-tools (Ubuntu):
importance: Undecided → High
assignee: nobody → Colin Watson (cjwatson)
status: New → Fix Committed
Changed in partman-iscsi (Ubuntu):
status: Fix Released → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package initramfs-tools - 0.92bubuntu63

---------------
initramfs-tools (0.92bubuntu63) lucid; urgency=low

  * init, scripts/functions: Add support for specifying a network interface
    by MAC address, using hwaddr= on the command line or HWADDR in an
    initramfs configuration file (LP: #473036).
 -- Colin Watson <email address hidden> Fri, 05 Feb 2010 11:49:34 -0800

Changed in initramfs-tools (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package partman-iscsi - 13

---------------
partman-iscsi (13) lucid; urgency=low

  * Set HWADDR rather than ISCSI_NETDEVICE, so that we select the default
    network interface by MAC address rather than by interface name
    (LP: #473036).
 -- Colin Watson <email address hidden> Fri, 05 Feb 2010 11:58:55 -0800

Changed in partman-iscsi (Ubuntu):
status: Triaged → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package open-iscsi - 2.0.871-0ubuntu4

---------------
open-iscsi (2.0.871-0ubuntu4) lucid; urgency=low

  * Revert ISCSI_NETDEVICE change; it's normally better to select the
    interface by MAC address (LP: #473036).
 -- Colin Watson <email address hidden> Fri, 05 Feb 2010 12:06:06 -0800

Changed in open-iscsi (Ubuntu):
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers